package com.huimv.eartag2.common.dao.entity;

import javax.persistence.*;
import java.io.Serializable;
import java.sql.Date;
import java.sql.Timestamp;

@Entity
@Table(name = "eartag_device_online")
public class EartagDeviceOnlineEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    private Integer id;

    @Column(name = "device_code")
    private String deviceCode;

    @Column(name = "alias")
    private String alias;

    @Column(name = "heartbeat_total")
    private Integer heartbeatTotal;

    @Column(name = "envtemp_total")
    private Integer envtempTotal;

    @Column(name = "eartag_total")
    private Integer eartagTotal;

    @Column(name = "first_time")
    private Timestamp firstTime;

    @Column(name = "last_time")
    private Timestamp lastTime;

    @Column(name = "last_envtemp")
    private Float lastEnvtemp;

    @Column(name = "last_eartag")
    private Float lastEartag;

    @Column(name = "add_date")
    private Date addDate;

    @Column(name = "farm_id")
    private Integer farmId;

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    public void setDeviceCode(String deviceCode) {
        this.deviceCode = deviceCode;
    }

    public String getDeviceCode() {
        return deviceCode;
    }

    public void setAlias(String alias) {
        this.alias = alias;
    }

    public String getAlias() {
        return alias;
    }

    public void setHeartbeatTotal(Integer heartbeatTotal) {
        this.heartbeatTotal = heartbeatTotal;
    }

    public Integer getHeartbeatTotal() {
        return heartbeatTotal;
    }

    public void setEnvtempTotal(Integer envtempTotal) {
        this.envtempTotal = envtempTotal;
    }

    public Integer getEnvtempTotal() {
        return envtempTotal;
    }

    public void setEartagTotal(Integer eartagTotal) {
        this.eartagTotal = eartagTotal;
    }

    public Integer getEartagTotal() {
        return eartagTotal;
    }

    public void setFirstTime(Timestamp firstTime) {
        this.firstTime = firstTime;
    }

    public Timestamp getFirstTime() {
        return firstTime;
    }

    public void setLastTime(Timestamp lastTime) {
        this.lastTime = lastTime;
    }

    public Timestamp getLastTime() {
        return lastTime;
    }

    public void setLastEnvtemp(Float lastEnvtemp) {
        this.lastEnvtemp = lastEnvtemp;
    }

    public Float getLastEnvtemp() {
        return lastEnvtemp;
    }

    public void setLastEartag(Float lastEartag) {
        this.lastEartag = lastEartag;
    }

    public Float getLastEartag() {
        return lastEartag;
    }

    public void setAddDate(Date addDate) {
        this.addDate = addDate;
    }

    public Date getAddDate() {
        return addDate;
    }

    public void setFarmId(Integer farmId) {
        this.farmId = farmId;
    }

    public Integer getFarmId() {
        return farmId;
    }

    @Override
    public String toString() {
        return "EartagDeviceOnlineEntity{" +
                "id=" + id + '\'' +
                "deviceCode=" + deviceCode + '\'' +
                "alias=" + alias + '\'' +
                "heartbeatTotal=" + heartbeatTotal + '\'' +
                "envtempTotal=" + envtempTotal + '\'' +
                "eartagTotal=" + eartagTotal + '\'' +
                "firstTime=" + firstTime + '\'' +
                "lastTime=" + lastTime + '\'' +
                "lastEnvtemp=" + lastEnvtemp + '\'' +
                "lastEartag=" + lastEartag + '\'' +
                "addDate=" + addDate + '\'' +
                "farmId=" + farmId + '\'' +
                '}';
    }
}
