package com.huimv.eartag2.process2.service.impl;

import com.huimv.eartag2.common.dao.entity.EartagDeviceRegisterEntity;
import com.huimv.eartag2.common.dao.entity.EartarFarmAllStatusEntity;
import com.huimv.eartag2.common.dao.repo.EartagDeviceRegisterRepo;
import com.huimv.eartag2.common.utils.BizConst;
import com.huimv.eartag2.common.utils.DateUtil;
import com.huimv.eartag2.process2.service.IRedisService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
@Slf4j
public class RedisServiceImpl implements IRedisService {
    @Autowired
    private RedisTemplate redisTemplate;
    @Autowired
    private EartagDeviceRegisterRepo eartagDeviceRegisterRepo;

    @Override
    public Boolean isExistTodayFarmAllStatus(String deviceCode) throws ParseException {
        System.out.println("isExistTodayFarmAllStatus 2.deviceCode>>"+deviceCode);

        //(1)从注册表缓存中（device_register_牧场id）取出牧场id,(2)如果缓存没有则从注册表（eartag_device_register）中查询00
        //(1)
        Object farmIdObj = redisTemplate.opsForHash().get(BizConst.DEVICE_REGISTER_PREFIX + deviceCode,"farmId");
        System.out.println("2.farmIdObj>>"+farmIdObj);
        String farmId = "";
        if(farmIdObj != null){
            farmId = farmIdObj.toString();
        }else{
            //(2)
            EartagDeviceRegisterEntity eartagDeviceRegisterEntity = eartagDeviceRegisterRepo.getDeviceRegister(deviceCode);
            System.out.println("2.eartagDeviceRegisterEntity>>"+eartagDeviceRegisterEntity.toString());
            if(eartagDeviceRegisterEntity == null){
                log.error("设备编号:"+deviceCode+",不存在.");
                return null;
            }
            farmId = eartagDeviceRegisterEntity.getFarmId();
        }
        System.out.println("2.farmId>>"+farmId);
        //从牧场总状态缓存中获取最近一次日期
        Object createDateObj = redisTemplate.opsForHash().get(BizConst.FARM_ALL_STATUS_PREFIX + farmId,"createDate");
        System.out.println("2.createDateObj>>"+createDateObj);
        if(createDateObj == null){
            //--总状态记录记录不存在
            System.out.println("A.");
            return false;
        }else{
            //
            String createDate = createDateObj.toString();
            System.out.println("缓存中上次操作日期 createDate>>"+createDate);
            if(new DateUtil().getTodayDateText().trim().equalsIgnoreCase(createDate)){
                //--当天记录存在，就返回true；
                System.out.println("B.");
                return true;
            }else{
                //--当天记录不存在，就返回false；
                System.out.println("C.");
                return false;
            }
        }
    }

    //# 读根据设备编码读取牧场id
    @Override
    public Object getFarmIdByDeviceCode(String deviceCode) {
        Object farmIdObj = redisTemplate.opsForHash().get(BizConst.DEVICE_REGISTER_PREFIX + deviceCode,"farmId");
        return farmIdObj;
    }

    @Override
    public Object getCreateDateByFarmId(String farmId) {
        return redisTemplate.opsForHash().get(BizConst.FARM_ALL_STATUS_PREFIX + farmId,"createDate");
    }

    @Override
    public void putFarmAllStatusCache(String farmId, EartarFarmAllStatusEntity farmAllStatusEntity) throws ParseException {
        DateUtil duObj = new DateUtil();
//        redisTemplate.opsForHash().putAll(BizConst.FARM_ALL_STATUS_PREFIX+farmId, allStatusMap);
        redisTemplate.opsForHash().put(BizConst.FARM_ALL_STATUS_PREFIX+farmId,"deviceOnline",farmAllStatusEntity.getDeviceOnline());
        redisTemplate.opsForHash().put(BizConst.FARM_ALL_STATUS_PREFIX+farmId,"deviceOffline",farmAllStatusEntity.getDeviceOffline());
        redisTemplate.opsForHash().put(BizConst.FARM_ALL_STATUS_PREFIX+farmId,"deviceRate",farmAllStatusEntity.getDeviceRate());
        redisTemplate.opsForHash().put(BizConst.FARM_ALL_STATUS_PREFIX+farmId,"updateTime",duObj.formatDateTime(duObj.getTodayText()));
    }

    //#
    public Object getValByKey(String hashKey,String key){
        Object valueObj = redisTemplate.opsForHash().get(hashKey,key);
        return valueObj;
    }
}
